VTK: vtkKochanekSpline Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkKochanekSpline Class Reference

computes an interpolating spline using a Kochanek basis. More...

`#include <vtkKochanekSpline.h>`

Inheritance diagram for vtkKochanekSpline:
[legend]
Collaboration diagram for vtkKochanekSpline:
[legend]

## Public Types
typedef vtkSpline | Superclass
Public Types inherited from vtkSpline
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkKochanekSpline * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Compute () override
| Compute Kochanek Spline coefficients. More...
double | Evaluate (double t) override
| Evaluate a 1D Kochanek spline. More...
void | DeepCopy (vtkSpline *s) override
| Deep copy of cardinal spline data. More...
virtual void | SetDefaultBias (double)
| Set the bias for all points. More...
virtual double | GetDefaultBias ()
| Set the bias for all points. More...
virtual void | SetDefaultTension (double)
| Set the tension for all points. More...
virtual double | GetDefaultTension ()
| Set the tension for all points. More...
virtual void | SetDefaultContinuity (double)
| Set the continuity for all points. More...
virtual double | GetDefaultContinuity ()
| Set the continuity for all points. More...
Public Member Functions inherited from vtkSpline
vtkSpline * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetNumberOfPoints ()
| Return the number of points inserted thus far. More...
void | AddPoint (double t, double x)
| Add a pair of points to be fit with the spline. More...
void | FillFromDataPointer (int nb, double *data)
| Add all the points to the list of points in one time, and then sort them only once. More...
void | RemovePoint (double t)
| Remove a point from the data to be fit with the spline. More...
void | RemoveAllPoints ()
| Remove all points from the data. More...
vtkMTimeType | GetMTime () override
| Return the MTime also considering the Piecewise function. More...
void | SetParametricRange (double tMin, double tMax)
| Set/Get the parametric range. More...
void | SetParametricRange (double tRange[2])
| Set/Get the parametric range. More...
void | GetParametricRange (double tRange[2]) const
| Set/Get the parametric range. More...
virtual void | SetClampValue (vtkTypeBool)
| Set/Get ClampValue. More...
virtual vtkTypeBool | GetClampValue ()
| Set/Get ClampValue. More...
virtual void | ClampValueOn ()
| Set/Get ClampValue. More...
virtual void | ClampValueOff ()
| Set/Get ClampValue. More...
virtual void | SetClosed (vtkTypeBool)
| Control whether the spline is open or closed. More...
virtual vtkTypeBool | GetClosed ()
| Control whether the spline is open or closed. More...
virtual void | ClosedOn ()
| Control whether the spline is open or closed. More...
virtual void | ClosedOff ()
| Control whether the spline is open or closed. More...
virtual void | SetLeftConstraint (int)
| Set the type of constraint of the left(right) end points. More...
virtual int | GetLeftConstraint ()
| Set the type of constraint of the left(right) end points. More...
virtual void | SetRightConstraint (int)
| Set the type of constraint of the left(right) end points. More...
virtual int | GetRightConstraint ()
| Set the type of constraint of the left(right) end points. More...
virtual void | SetLeftValue (double)
| The values of the derivative on the left and right sides. More...
virtual double | GetLeftValue ()
| The values of the derivative on the left and right sides. More...
virtual void | SetRightValue (double)
| The values of the derivative on the left and right sides. More...
virtual double | GetRightValue ()
| The values of the derivative on the left and right sides. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkKochanekSpline * | SafeDownCast (vtkObjectBase *o)
static vtkKochanekSpline * | New ()
| Construct a KochanekSpline with the following defaults: DefaultBias = 0, DefaultTension = 0, DefaultContinuity = 0. More...
Static Public Member Functions inherited from vtkSpline
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSpline * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkKochanekSpline ()
| ~vtkKochanekSpline () override=default
void | Fit1D (int size, double *x, double *y, double tension, double bias, double continuity, double coefficients[][4], int leftConstraint, double leftValue, int rightConstraint, double rightValue)
Protected Member Functions inherited from vtkSpline
| vtkSpline ()
| ~vtkSpline () override
double | ComputeLeftDerivative ()
double | ComputeRightDerivative ()
int | FindIndex (int size, double t)
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | DefaultBias
double | DefaultTension
double | DefaultContinuity
Protected Attributes inherited from vtkSpline
vtkMTimeType | ComputeTime
vtkTypeBool | ClampValue
double * | Intervals
double * | Coefficients
int | LeftConstraint
double | LeftValue
int | RightConstraint
double | RightValue
vtkPiecewiseFunction * | PiecewiseFunction
vtkTypeBool | Closed
double | ParametricRange [2]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

computes an interpolating spline using a Kochanek basis.

Implements the Kochanek interpolating spline described in: Kochanek, D., Bartels, R., "Interpolating Splines with Local Tension, Continuity, and Bias Control," Computer Graphics, vol. 18, no. 3, pp. 33-41, July 1984. These splines give the user more control over the shape of the curve than the cardinal splines implemented in vtkCardinalSpline. Three parameters can be specified. All have a range from -1 to 1.

Tension controls how sharply the curve bends at an input point. A value of -1 produces more slack in the curve. A value of 1 tightens the curve.

Continuity controls the continuity of the first derivative at input points.

Bias controls the direction of the curve at it passes through an input point. A value of -1 undershoots the point while a value of 1 overshoots the point.

These three parameters give the user broad control over the shape of the interpolating spline. The original Kochanek paper describes the effects nicely and is recommended reading.

See also
  vtkSpline vtkCardinalSpline

Online Examples:

Tests:
  vtkKochanekSpline (Tests)

Definition at line 52 of file vtkKochanekSpline.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkSpline vtkKochanekSpline::Superclass

Definition at line 55 of file vtkKochanekSpline.h.

## Constructor & Destructor Documentation

## ◆ vtkKochanekSpline()

vtkKochanekSpline::vtkKochanekSpline | ( |  | ) |
| protected

## ◆ ~vtkKochanekSpline()

vtkKochanekSpline::~vtkKochanekSpline | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkKochanekSpline::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkKochanekSpline::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkSpline.

## ◆ SafeDownCast()

static vtkKochanekSpline* vtkKochanekSpline::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkKochanekSpline::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkSpline.

## ◆ NewInstance()

vtkKochanekSpline* vtkKochanekSpline::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkKochanekSpline::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObjectBase.

## ◆ New()

static vtkKochanekSpline* vtkKochanekSpline::New | ( |  | ) |
| static

Construct a KochanekSpline with the following defaults: DefaultBias = 0, DefaultTension = 0, DefaultContinuity = 0.

## ◆ Compute()

void vtkKochanekSpline::Compute | ( |  | ) |
| overridevirtual

Compute Kochanek Spline coefficients.

Implements vtkSpline.

## ◆ Evaluate()

double vtkKochanekSpline::Evaluate | ( | double | t | ) |
| overridevirtual

Evaluate a 1D Kochanek spline.

Implements vtkSpline.

## ◆ SetDefaultBias()

virtual void vtkKochanekSpline::SetDefaultBias | ( | double |  | ) |
| virtual

Set the bias for all points.

Default is 0.

## ◆ GetDefaultBias()

virtual double vtkKochanekSpline::GetDefaultBias | ( |  | ) |
| virtual

Set the bias for all points.

Default is 0.

## ◆ SetDefaultTension()

virtual void vtkKochanekSpline::SetDefaultTension | ( | double |  | ) |
| virtual

Set the tension for all points.

Default is 0.

## ◆ GetDefaultTension()

virtual double vtkKochanekSpline::GetDefaultTension | ( |  | ) |
| virtual

Set the tension for all points.

Default is 0.

## ◆ SetDefaultContinuity()

virtual void vtkKochanekSpline::SetDefaultContinuity | ( | double |  | ) |
| virtual

Set the continuity for all points.

Default is 0.

## ◆ GetDefaultContinuity()

virtual double vtkKochanekSpline::GetDefaultContinuity | ( |  | ) |
| virtual

Set the continuity for all points.

Default is 0.

## ◆ DeepCopy()

void vtkKochanekSpline::DeepCopy | ( | vtkSpline * | s | ) |
| overridevirtual

Deep copy of cardinal spline data.

Reimplemented from vtkSpline.

## ◆ Fit1D()

void vtkKochanekSpline::Fit1D | ( | int | size,
|  | double * | x,
|  | double * | y,
|  | double | tension,
|  | double | bias,
|  | double | continuity,
|  | double | coefficients[][4],
|  | int | leftConstraint,
|  | double | leftValue,
|  | int | rightConstraint,
|  | double | rightValue
| ) |  |
| protected

## Member Data Documentation

## ◆ DefaultBias

double vtkKochanekSpline::DefaultBias
| protected

Definition at line 111 of file vtkKochanekSpline.h.

## ◆ DefaultTension

double vtkKochanekSpline::DefaultTension
| protected

Definition at line 112 of file vtkKochanekSpline.h.

## ◆ DefaultContinuity

double vtkKochanekSpline::DefaultContinuity
| protected

Definition at line 113 of file vtkKochanekSpline.h.

The documentation for this class was generated from the following file:

- Common/ComputationalGeometry/vtkKochanekSpline.h